com.fasterxml.jackson.databind.introspect

## Class BasicBeanDescription

- java.lang.Object
- - com.fasterxml.jackson.databind.BeanDescription
  - - com.fasterxml.jackson.databind.introspect.BasicBeanDescription

    public class BasicBeanDescription
    extends BeanDescription

Default `BeanDescription` implementation used by Jackson.

Although sub-classing is a theoretical possibility there are no known use cases for that, nor is such usage tested or supported. Separation from API is mostly to isolate some implementation details here and keep API simple.

### Field Summary

Fields
`protected AnnotationIntrospector` `_annotationIntrospector`
`protected AnnotatedClass` `_classInfo` Information collected about the class introspected.
`protected MapperConfig<?>` `_config`
`protected Class<?>[]` `_defaultViews`
`protected boolean` `_defaultViewsResolved`
`protected ObjectIdInfo` `_objectIdInfo` Details of Object Id to include, if any
`protected POJOPropertiesCollector` `_propCollector` We will hold a reference to the collector in cases where information is lazily accessed and constructed; properties are only accessed when they are actually needed.
`protected List<BeanPropertyDefinition>` `_properties` Properties collected for the POJO; initialized as needed.

### Fields inherited from class com.fasterxml.jackson.databind.BeanDescription

`_type`

### Constructor Summary

Constructors
`protected` `BasicBeanDescription(MapperConfig<?> config, JavaType type, AnnotatedClass classDef, List<BeanPropertyDefinition> props)` Alternate constructor used in cases where property information is not needed, only class info.
`protected` `BasicBeanDescription(POJOPropertiesCollector coll)`
`protected` `BasicBeanDescription(POJOPropertiesCollector coll, JavaType type, AnnotatedClass classDef)`

### Method Summary

Methods
`protected Converter<Object,Object>` `_createConverter(Object converterDef)`
`protected PropertyName` `_findCreatorPropertyName(AnnotatedParameter param)` Deprecated. since 2.8
`LinkedHashMap<String,AnnotatedField>` `_findPropertyFields(Collection<String> ignoredProperties, boolean forSerialization)` Deprecated. Since 2.7.2, does not seem to be used?
`protected List<BeanPropertyDefinition>` `_properties()`
`boolean` `addProperty(BeanPropertyDefinition def)`
`TypeBindings` `bindingsForBeanType()` Deprecated.
`AnnotatedMember` `findAnyGetter()` Method used to locate the method of introspected class that implements `JsonAnyGetter`.
`AnnotatedMember` `findAnySetterAccessor()` Method used to locate a mutator (settable field, or 2-argument set method) of introspected class that implements `JsonAnySetter`.
`Map<String,AnnotatedMember>` `findBackReferenceProperties()` Deprecated.
`List<BeanPropertyDefinition>` `findBackReferences()` Method for locating all back-reference properties (setters, fields) bean has
`String` `findClassDescription()` Accessor for possible description for the bean type, used for constructing documentation.
`AnnotatedConstructor` `findDefaultConstructor()` Method that will locate the no-arg constructor for this class, if it has one, and that constructor has not been marked as ignorable.
`Class<?>[]` `findDefaultViews()` Method for finding out if the POJO specifies default view(s) to use for properties, considering both per-type annotations and global default settings.
`Converter<Object,Object>` `findDeserializationConverter()` Method for finding `Converter` used for serializing instances of this class.
`JsonFormat.Value` `findExpectedFormat(JsonFormat.Value defValue)` Method for checking what is the expected format for POJO, as defined by defaults and possible annotations.
`Method` `findFactoryMethod(Class<?>... expArgTypes)` Method that can be called to find if introspected class declares a static "valueOf" factory method that returns an instance of introspected type, given one of acceptable types.
`Map<Object,AnnotatedMember>` `findInjectables()`
`AnnotatedMember` `findJsonValueAccessor()` Method for locating accessor (readable field, or "getter" method) that has `JsonValue` annotation, if any.
`AnnotatedMethod` `findJsonValueMethod()` Deprecated.
`AnnotatedMethod` `findMethod(String name, Class<?>[] paramTypes)`
`Class<?>` `findPOJOBuilder()` Method for checking if the POJO type has annotations to indicate that a builder is to be used for instantiating instances and handling data binding, instead of standard bean deserializer.
`JsonPOJOBuilder.Value` `findPOJOBuilderConfig()` Method for finding configuration for POJO Builder class.
`List<BeanPropertyDefinition>` `findProperties()`
`BeanPropertyDefinition` `findProperty(PropertyName name)`
`JsonInclude.Value` `findPropertyInclusion(JsonInclude.Value defValue)` Method for determining whether null properties should be written out for a Bean of introspected type.
`Converter<Object,Object>` `findSerializationConverter()` Method for finding `Converter` used for serializing instances of this class.
`Constructor<?>` `findSingleArgConstructor(Class<?>... argTypes)` Method that can be called to locate a single-arg constructor that takes specified exact type (will not accept supertype constructors)
`static BasicBeanDescription` `forDeserialization(POJOPropertiesCollector coll)` Factory method to use for constructing an instance to use for building deserializers.
`static BasicBeanDescription` `forOtherUse(MapperConfig<?> config, JavaType type, AnnotatedClass ac)` Factory method to use for constructing an instance to use for purposes other than building serializers or deserializers; will only have information on class, not on properties.
`static BasicBeanDescription` `forSerialization(POJOPropertiesCollector coll)` Factory method to use for constructing an instance to use for building serializers.
`Annotations` `getClassAnnotations()` Method for accessing collection of annotations the bean class has.
`AnnotatedClass` `getClassInfo()` Method for accessing low-level information about Class this item describes.
`List<AnnotatedConstructor>` `getConstructors()`
`List<AnnotatedMethod>` `getFactoryMethods()`
`Set<String>` `getIgnoredPropertyNames()`
`ObjectIdInfo` `getObjectIdInfo()` Accessor for getting information about Object Id expected to be used for this POJO type, if any.
`boolean` `hasKnownClassAnnotations()` Method for checking whether class being described has any annotations recognized by registered annotation introspector.
`boolean` `hasProperty(PropertyName name)`
`Object` `instantiateBean(boolean fixAccess)` Method called to create a "default instance" of the bean, currently only needed for obtaining default field values which may be used for suppressing serialization of fields that have "not changed".
`protected boolean` `isFactoryMethod(AnnotatedMethod am)`
`boolean` `removeProperty(String propName)` Method that can be used to prune unwanted properties, during construction of serializers and deserializers.
`JavaType` `resolveType(Type jdkType)` Deprecated.

### Methods inherited from class com.fasterxml.jackson.databind.BeanDescription

`findAnySetter, findAnySetterField, getBeanClass, getType, isNonStaticInnerClass`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _propCollector

    protected final POJOPropertiesCollector _propCollector

We will hold a reference to the collector in cases where information is lazily accessed and constructed; properties are only accessed when they are actually needed.

#### _config

    protected final MapperConfig<?> _config

#### _annotationIntrospector

    protected final AnnotationIntrospector _annotationIntrospector

#### _classInfo

    protected final AnnotatedClass _classInfo

Information collected about the class introspected.

#### _defaultViews

    protected Class<?>[] _defaultViews

Since:
  2.9

#### _defaultViewsResolved

    protected boolean _defaultViewsResolved

Since:
  2.9

#### _properties

    protected List<BeanPropertyDefinition> _properties

Properties collected for the POJO; initialized as needed.

#### _objectIdInfo

    protected ObjectIdInfo _objectIdInfo

Details of Object Id to include, if any

### Constructor Detail

#### BasicBeanDescription

    protected BasicBeanDescription(POJOPropertiesCollector coll,
                        JavaType type,
                        AnnotatedClass classDef)

#### BasicBeanDescription

    protected BasicBeanDescription(MapperConfig<?> config,
                        JavaType type,
                        AnnotatedClass classDef,
                        List<BeanPropertyDefinition> props)

Alternate constructor used in cases where property information is not needed, only class info.

#### BasicBeanDescription

    protected BasicBeanDescription(POJOPropertiesCollector coll)

### Method Detail

#### forDeserialization

    public static BasicBeanDescription forDeserialization(POJOPropertiesCollector coll)

Factory method to use for constructing an instance to use for building deserializers.

#### forSerialization

    public static BasicBeanDescription forSerialization(POJOPropertiesCollector coll)

Factory method to use for constructing an instance to use for building serializers.

#### forOtherUse

    public static BasicBeanDescription forOtherUse(MapperConfig<?> config,
                                   JavaType type,
                                   AnnotatedClass ac)

Factory method to use for constructing an instance to use for purposes other than building serializers or deserializers; will only have information on class, not on properties.

#### _properties

    protected List<BeanPropertyDefinition> _properties()

#### removeProperty

    public boolean removeProperty(String propName)

Method that can be used to prune unwanted properties, during construction of serializers and deserializers. Use with utmost care, if at all...

Since:
  2.1

#### addProperty

    public boolean addProperty(BeanPropertyDefinition def)

#### hasProperty

    public boolean hasProperty(PropertyName name)

Since:
  2.6

#### findProperty

    public BeanPropertyDefinition findProperty(PropertyName name)

Since:
  2.6

#### getClassInfo

    public AnnotatedClass getClassInfo()

Description copied from class: `BeanDescription`
Method for accessing low-level information about Class this item describes.

Specified by:
  `getClassInfo` in class `BeanDescription`

#### getObjectIdInfo

    public ObjectIdInfo getObjectIdInfo()

Description copied from class: `BeanDescription`
Accessor for getting information about Object Id expected to be used for this POJO type, if any.

Specified by:
  `getObjectIdInfo` in class `BeanDescription`

#### findProperties

    public List<BeanPropertyDefinition> findProperties()

Specified by:
  `findProperties` in class `BeanDescription`
Returns:
  Ordered Map with logical property name as key, and matching getter method as value.

#### findJsonValueMethod

    @Deprecated
    public AnnotatedMethod findJsonValueMethod()

Deprecated.

Specified by:
  `findJsonValueMethod` in class `BeanDescription`

#### findJsonValueAccessor

    public AnnotatedMember findJsonValueAccessor()

Description copied from class: `BeanDescription`
Method for locating accessor (readable field, or "getter" method) that has `JsonValue` annotation, if any. If multiple ones are found, an error is reported by throwing `IllegalArgumentException`

Specified by:
  `findJsonValueAccessor` in class `BeanDescription`

#### getIgnoredPropertyNames

    public Set<String> getIgnoredPropertyNames()

Specified by:
  `getIgnoredPropertyNames` in class `BeanDescription`

#### hasKnownClassAnnotations

    public boolean hasKnownClassAnnotations()

Description copied from class: `BeanDescription`
Method for checking whether class being described has any annotations recognized by registered annotation introspector.

Specified by:
  `hasKnownClassAnnotations` in class `BeanDescription`

#### getClassAnnotations

    public Annotations getClassAnnotations()

Description copied from class: `BeanDescription`
Method for accessing collection of annotations the bean class has.

Specified by:
  `getClassAnnotations` in class `BeanDescription`

#### bindingsForBeanType

    @Deprecated
    public TypeBindings bindingsForBeanType()

Deprecated.
Description copied from class: `BeanDescription`
Accessor for type bindings that may be needed to fully resolve types of member object, such as return and argument types of methods and constructors, and types of fields.

Specified by:
  `bindingsForBeanType` in class `BeanDescription`

#### resolveType

    @Deprecated
    public JavaType resolveType(Type jdkType)

Deprecated.
Description copied from class: `BeanDescription`
Method for resolving given JDK type, using this bean as the generic type resolution context.

Specified by:
  `resolveType` in class `BeanDescription`

#### findDefaultConstructor

    public AnnotatedConstructor findDefaultConstructor()

Description copied from class: `BeanDescription`
Method that will locate the no-arg constructor for this class, if it has one, and that constructor has not been marked as ignorable.

Specified by:
  `findDefaultConstructor` in class `BeanDescription`

#### findAnySetterAccessor

    public AnnotatedMember findAnySetterAccessor()
                                          throws IllegalArgumentException

Description copied from class: `BeanDescription`
Method used to locate a mutator (settable field, or 2-argument set method) of introspected class that implements `JsonAnySetter`. If no such mutator exists null is returned. If more than one are found, an exception is thrown. Additional checks are also made to see that method signature is acceptable: needs to take 2 arguments, first one String or Object; second any can be any type.

Specified by:
  `findAnySetterAccessor` in class `BeanDescription`
Throws:
  `IllegalArgumentException`

#### findInjectables

    public Map<Object,AnnotatedMember> findInjectables()

Specified by:
  `findInjectables` in class `BeanDescription`

#### getConstructors

    public List<AnnotatedConstructor> getConstructors()

Specified by:
  `getConstructors` in class `BeanDescription`

#### instantiateBean

    public Object instantiateBean(boolean fixAccess)

Description copied from class: `BeanDescription`
Method called to create a "default instance" of the bean, currently only needed for obtaining default field values which may be used for suppressing serialization of fields that have "not changed".

Specified by:
  `instantiateBean` in class `BeanDescription`
Parameters:
  `fixAccess` - If true, method is allowed to fix access to the default constructor (to be able to call non-public constructor); if false, has to use constructor as is.
Returns:
  Instance of class represented by this descriptor, if suitable default constructor was found; null otherwise.

#### findMethod

    public AnnotatedMethod findMethod(String name,
                             Class<?>[] paramTypes)

Specified by:
  `findMethod` in class `BeanDescription`

#### findExpectedFormat

    public JsonFormat.Value findExpectedFormat(JsonFormat.Value defValue)

Description copied from class: `BeanDescription`
Method for checking what is the expected format for POJO, as defined by defaults and possible annotations. Note that this may be further refined by per-property annotations.

Specified by:
  `findExpectedFormat` in class `BeanDescription`

#### findDefaultViews

    public Class<?>[] findDefaultViews()

Description copied from class: `BeanDescription`
Method for finding out if the POJO specifies default view(s) to use for properties, considering both per-type annotations and global default settings.

Specified by:
  `findDefaultViews` in class `BeanDescription`

#### findSerializationConverter

    public Converter<Object,Object> findSerializationConverter()

Description copied from class: `BeanDescription`
Method for finding `Converter` used for serializing instances of this class.

Specified by:
  `findSerializationConverter` in class `BeanDescription`

#### findPropertyInclusion

    public JsonInclude.Value findPropertyInclusion(JsonInclude.Value defValue)

Method for determining whether null properties should be written out for a Bean of introspected type. This is based on global feature (lowest priority, passed as argument) and per-class annotation (highest priority).

Specified by:
  `findPropertyInclusion` in class `BeanDescription`

#### findAnyGetter

    public AnnotatedMember findAnyGetter()
                                  throws IllegalArgumentException

Method used to locate the method of introspected class that implements `JsonAnyGetter`. If no such method exists null is returned. If more than one are found, an exception is thrown.

Specified by:
  `findAnyGetter` in class `BeanDescription`
Throws:
  `IllegalArgumentException`

#### findBackReferences

    public List<BeanPropertyDefinition> findBackReferences()

Description copied from class: `BeanDescription`
Method for locating all back-reference properties (setters, fields) bean has

Specified by:
  `findBackReferences` in class `BeanDescription`

#### findBackReferenceProperties

    @Deprecated
    public Map<String,AnnotatedMember> findBackReferenceProperties()

Deprecated.
Description copied from class: `BeanDescription`
Method for locating all back-reference properties (setters, fields) bean has

Specified by:
  `findBackReferenceProperties` in class `BeanDescription`

#### getFactoryMethods

    public List<AnnotatedMethod> getFactoryMethods()

Specified by:
  `getFactoryMethods` in class `BeanDescription`

#### findSingleArgConstructor

    public Constructor<?> findSingleArgConstructor(Class<?>... argTypes)

Description copied from class: `BeanDescription`
Method that can be called to locate a single-arg constructor that takes specified exact type (will not accept supertype constructors)

Specified by:
  `findSingleArgConstructor` in class `BeanDescription`
Parameters:
  `argTypes` - Type(s) of the argument that we are looking for

#### findFactoryMethod

    public Method findFactoryMethod(Class<?>... expArgTypes)

Description copied from class: `BeanDescription`
Method that can be called to find if introspected class declares a static "valueOf" factory method that returns an instance of introspected type, given one of acceptable types.

Specified by:
  `findFactoryMethod` in class `BeanDescription`
Parameters:
  `expArgTypes` - Types that the matching single argument factory method can take: will also accept super types of these types (ie. arg just has to be assignable from expArgType)

#### isFactoryMethod

    protected boolean isFactoryMethod(AnnotatedMethod am)

#### _findCreatorPropertyName

    @Deprecated
    protected PropertyName _findCreatorPropertyName(AnnotatedParameter param)

Deprecated. since 2.8

#### findPOJOBuilder

    public Class<?> findPOJOBuilder()

Description copied from class: `BeanDescription`
Method for checking if the POJO type has annotations to indicate that a builder is to be used for instantiating instances and handling data binding, instead of standard bean deserializer.

Specified by:
  `findPOJOBuilder` in class `BeanDescription`

#### findPOJOBuilderConfig

    public JsonPOJOBuilder.Value findPOJOBuilderConfig()

Description copied from class: `BeanDescription`
Method for finding configuration for POJO Builder class.

Specified by:
  `findPOJOBuilderConfig` in class `BeanDescription`

#### findDeserializationConverter

    public Converter<Object,Object> findDeserializationConverter()

Description copied from class: `BeanDescription`
Method for finding `Converter` used for serializing instances of this class.

Specified by:
  `findDeserializationConverter` in class `BeanDescription`

#### findClassDescription

    public String findClassDescription()

Description copied from class: `BeanDescription`
Accessor for possible description for the bean type, used for constructing documentation.

Overrides:
  `findClassDescription` in class `BeanDescription`

#### _findPropertyFields

    @Deprecated
    public LinkedHashMap<String,AnnotatedField> _findPropertyFields(Collection<String> ignoredProperties,
                                                                      boolean forSerialization)

Deprecated. Since 2.7.2, does not seem to be used?

Parameters:
  `ignoredProperties` - (optional) names of properties to ignore; any fields that would be recognized as one of these properties is ignored.
  `forSerialization` - If true, will collect serializable property fields; if false, deserializable
Returns:
  Ordered Map with logical property name as key, and matching field as value.

#### _createConverter

    protected Converter<Object,Object> _createConverter(Object converterDef)